package com.tencent.edu.kernel.http.util

import com.google.gson.JsonObject

object GsonUtil {
    @JvmStatic
    @JvmOverloads
    fun getInt(jsonObject: JsonObject, name: String, defaultValue: Int = -1): Int {
        val jsonElement = jsonObject[name]
        return jsonElement?.asInt ?: defaultValue
    }

    @JvmStatic
    @JvmOverloads
    fun getString(jsonObject: JsonObject, name: String, defaultValue: String? = null): String? {
        val jsonElement = jsonObject[name]
        return jsonElement?.asString ?: defaultValue
    }

    @JvmStatic
    @JvmOverloads
    fun getBoolean(jsonObject: JsonObject, name: String, defaultValue: Boolean = false): Boolean {
        val jsonElement = jsonObject[name]
        return jsonElement?.asBoolean ?: defaultValue
    }

    @JvmStatic
    @JvmOverloads
    fun getLong(jsonObject: JsonObject, name: String, defaultValue: Long = 0): Long {
        val jsonElement = jsonObject[name]
        return jsonElement?.asLong ?: defaultValue
    }
}