package com.tencent.edu.module.chat.view

import android.content.Context
import android.util.AttributeSet
import com.handmark.pulltorefresh.library.PullToRefreshListView

/**
 * 私聊页聊天列表
 * @author aidanyang
 * @date 2020-04-27
 */
class ChatPrivateListView : PullToRefreshListView {
    // 初始化列表时会初始化头部动画
    private var isInit = true
    // 当为输入法造成的大小变化时，不使用父类的onSizeChange方法
    private var isBanSizeChange = true

    constructor(context: Context) : super(context)

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs)

    constructor(context: Context, mode: Mode) : super(context, mode)

    constructor(context: Context, mode: Mode, style: AnimationStyle) : super(context, mode, style)

    override fun onSizeChanged(w: Int, h: Int, oldw: Int, oldh: Int) {
        if (isInit || !isBanSizeChange) {
            isInit = false
            // 此项方法会造成列表页在大小变化的时候闪屏（输入法将界面顶起场景）
            // 所以在不需要下拉加载时屏蔽此功能
            // 如果没有此方法，下拉加载动画不会显示
            super.onSizeChanged(w, h, oldw, oldh)
        }
    }

    // 屏蔽 调整下拉刷新View ，私聊页面不需要下拉刷新
    // 此方法会造成列表页被顶起时列表内布局混乱
    override fun refreshRefreshableViewSize(width: Int, height: Int) {
    }

    override fun onScrollChanged(l: Int, t: Int, oldl: Int, oldt: Int) {
        // 当top>0时，屏蔽onSizeChanged方法
        // 当top<0时，放开onSizeChanged方法
        isBanSizeChange = t >= 0
        super.onScrollChanged(l, t, oldl, oldt)
    }

}