package com.tencent.edu.module.course.detail.util

import android.os.CountDownTimer
import com.tencent.edu.common.core.ThreadMgr
import com.tencent.edu.common.misc.WeakReference
import com.tencent.edu.module.course.detail.top.CourseDetailEnjoyStudyView
import com.tencent.edu.module.homepage.data.EnjoyStudyCardRequester

object EnjoyStudyViewController {

    var mSecUntilFinished: Int = -1
    private var mTimer: CountDownTimer? = null
    private var mReference: WeakReference<CourseDetailEnjoyStudyView>? = null
    private var mTermId: String? = null

    fun getView() = mReference?.get()

    fun startTimer(view: CourseDetailEnjoyStudyView, leftSec: Int, termId: String) {
        mReference = WeakReference(view)

        if (mTermId == termId && mSecUntilFinished != -1) {
            if (mSecUntilFinished == 0) {
                getView()?.setCanGrant()
            } else {
                startTimer(mSecUntilFinished)
            }
            return
        }

        mTermId = termId
        mSecUntilFinished = -1

        startTimer(leftSec)
    }

    private fun startTimer(leftSec: Int) {
        pauseTimer()
        mTimer = object : CountDownTimer((leftSec * 1000).toLong(), 1000) {
            override fun onTick(millisUntilFinished: Long) {
                mSecUntilFinished = millisUntilFinished.toInt() / 1000
                EnjoyStudyCardRequester.mDetail?.apply {
                    already_study_sec++
                }

                ThreadMgr.postToUIThread {
                    getView()?.updateCountDownText(mSecUntilFinished)
                }
            }

            override fun onFinish() {
                mSecUntilFinished = 0
                EnjoyStudyCardRequester.mDetail?.apply {
                    already_study_sec = this.need_study_sec
                }

                ThreadMgr.postToUIThread {
                    getView()?.setCanGrant()
                }
            }
        }
        mTimer!!.start()
    }

    fun pauseTimer() {
        mTimer?.cancel()
        mTimer = null
    }

    fun unInit() {
        pauseTimer()
        mSecUntilFinished = -1
        mTermId = null
        mReference?.clear()
        mReference = null
    }

}