package com.tencent.edu.module.course.task.courseware

import android.os.Environment

class FilePreviewUtils {
    companion object {
        @JvmField
        val SUPPORT_DOC = listOf("doc", "docx", "ppt", "pptx", "xls", "xlsx", "pdf", "txt", "wps", "html", "css", "js");

        @JvmField
        val SUPPORT_IMG = listOf("png", "jpg", "jpeg", "psd", "bmp", "webp", "gif", "lbm", "iff", "svg")

        @JvmField
        val SUPPORT_ZIP = listOf("zip", "rar")

        @JvmField
        val SUPPORT_VIDEO = listOf("mp4", "flv"/*, "avi", "mkv", "rm", "rmvb", "mov", "wmv"*/)

        @JvmField
        val SUPPORT_AUDIO = listOf("mp3", /*"wav", "ogg", "wma", "asf",*/ "aac")

        @JvmStatic
        fun isSupport(type: String): Boolean {
            return isDoc(type) || isImg(type) || isZip(type) || isVideo(type) || isAudio(type)
        }

        @JvmStatic
        fun isDoc(type: String): Boolean {
            return type in SUPPORT_DOC
        }

        @JvmStatic
        fun isImg(type: String): Boolean {
            return type in SUPPORT_IMG
        }

        @JvmStatic
        fun isZip(type: String): Boolean {
            return type in SUPPORT_ZIP
        }

        fun isVideo(type: String): Boolean {
            return type in SUPPORT_VIDEO
        }

        @JvmStatic
        fun isAudio(type: String): Boolean {
            return type in SUPPORT_AUDIO
        }

        @JvmField
        val DOC = 0

        @JvmField
        val AUDIO = 1

        @JvmField
        val VIDEO = 2

        @JvmField
        val IMG = 3

        @JvmField
        val ZIP = 4

        @JvmField
        val OTHER = 5

        @JvmStatic
        fun isDoc(type: Int): Boolean {
            return type == DOC
        }

        @JvmStatic
        fun isImg(type: Int): Boolean {
            return type == IMG
        }

        @JvmStatic
        fun isZip(type: Int): Boolean {
            return type == ZIP
        }

        fun isVideo(type: Int): Boolean {
            return type == VIDEO
        }

        @JvmStatic
        fun isAudio(type: Int): Boolean {
            return type == AUDIO
        }

        @JvmStatic
        val PREVIEW_DIR = Environment.getExternalStorageDirectory().absolutePath + "/Android/data/com.tencent.edu/files/tencentedu/biz/filepreview/"

        @JvmStatic
        fun getDirPath(coursewareId: String): String {
            return "$PREVIEW_DIR$coursewareId/"
        }

        @JvmStatic
        fun getFilePath(coursewareId: String, name: String): String {
            return "$PREVIEW_DIR$coursewareId/$name"
        }

    }
}