package com.tencent.edu.module.login

import android.content.Context
import android.content.Intent
import android.os.Bundle

import com.tencent.edu.R
import com.tencent.edu.common.misc.WeakReference
import com.tencent.edu.common.utils.ClickTooFastProtectUtil
import com.tencent.edu.common.utils.ClickTooFastProtectUtil.TIME_500_MS
import com.tencent.edu.commonview.activity.EduCompatActivity
import com.tencent.edu.module.LoginActivity
import kotlinx.android.synthetic.main.activity_more_login_way.*

/**
 * 更多登录方式页.
 *
 * @author aidanyang
 */
class LoginMoreWayActivity : EduCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_more_login_way)

        setCommonActionBar()

        setActionBarTitle(R.string.other_login_way)

        setActionBarDividerVisible(false)

        // 登录成功时，当前页面也会一起finish
        LoginActivity.mLoginActivityStack.add(WeakReference(this))

        login_gray_mobile_tv.setOnClickListener {
            if (!ClickTooFastProtectUtil.isClickTooFast(login_gray_mobile_tv.id.toString(), TIME_500_MS.toLong())) {
                val toHomepage = intent.getBooleanExtra("homepage", true)
                LoginActivity.startLoginActivity(this, toHomepage, LoginCustomView.TYPE_MOBILE, -1, true)
            }
        }
        login_gray_sso_tv.setOnClickListener {
            if (!ClickTooFastProtectUtil.isClickTooFast(login_gray_sso_tv.id.toString(), TIME_500_MS.toLong()))
                LoginSSOActivity.start(this, true)
        }
    }


    companion object {
        fun start(context: Context, isLoginToHomePage: Boolean) {
            val intent = Intent(context, LoginMoreWayActivity::class.java)
            intent.putExtra("homepage", isLoginToHomePage)
            context.startActivity(intent)
        }
    }
}
