package com.tencent.edu.module.login.nationdialog

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.tencent.edu.R

/**
 * @author aidanyang
 * @date 2020-1-27
 */
class NationAdapter(var mContext: Context, var data: List<NationCodeItem>?) : RecyclerView.Adapter<NationAdapter.ViewHolder>() {
    private val mInflater: LayoutInflater = LayoutInflater.from(mContext)
    private var mItemClickListener: ((View?, NationCodeItem, Int) -> Unit)? = null

    fun setData(data: List<NationCodeItem>?): NationAdapter {
        this.data = data
        return this
    }

    fun setOnItemClickListener(listener: ((View?, NationCodeItem, Int) -> Unit)) {
        mItemClickListener = listener
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(mInflater.inflate(R.layout.item_nation_code, parent, false))
    }

    @SuppressLint("SetTextI18n")
    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val item = data!![position]

        holder.itemView.setOnClickListener { v ->
            mItemClickListener?.invoke(v, item, position)
        }
        holder.tvName.text = item.name
        holder.tvCode.text = "+${item.dialing_code}"
    }

    override fun getItemCount(): Int {
        return data?.size ?: 0
    }

    class ViewHolder internal constructor(itemView: View) : RecyclerView.ViewHolder(itemView) {
        var tvCode: TextView = itemView.findViewById(R.id.nation_code_tv)
        var tvName: TextView = itemView.findViewById(R.id.nation_name_tv)
    }
}