package com.tencent.edu.module.login.nationdialog

import com.tencent.edu.module.login.nationdialog.indexlib.indexbar.bean.BaseIndexPinyinBean
import java.io.Serializable

data class NationCodeGroup(
        val `data`: List<NationCodeItem> = arrayListOf(),
        val label: String = "#"
) : Serializable

data class NationCodeItem(
        val dialing_code: String = "86",
        val iso_code: String = "CN",
        val name: String = "中国大陆",
        val pinyin: String = "zhongguo",
        val region: String = "China",
        var top: Boolean = false
) : BaseIndexPinyinBean(), Serializable {

    init {
        baseIndexTag = "#"
    }

    override fun getTarget(): String {
        return name
    }

    override fun isNeedToPinyin(): Boolean {
        return false
    }

    override fun isShowSuspension(): Boolean {
        return !top
    }

    override fun toString(): String {
        return "NationCodeItem(dialing_code='$dialing_code', iso_code='$iso_code', name='$name', pinyin='$pinyin', region='$region', top=$top)"
    }

}