package com.tencent.edu.module.shortvideo.playerview

import android.app.Activity
import android.content.Context
import android.text.Html
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.view.View.OnClickListener
import android.view.animation.AlphaAnimation
import android.widget.RelativeLayout
import com.tencent.edu.R
import com.tencent.edu.common.utils.MiscUtils
import com.tencent.edu.module.share.ShareSelector
import com.tencent.edu.module.shortvideo.bean.VideoBean
import com.tencent.edu.module.shortvideo.util.ShortVideoShareUtil
import com.tencent.edu.module.vodplayer.widget.DefinitionSelectDlg
import com.tencent.edu.module.webinfopages.data.CommonShare
import kotlinx.android.synthetic.main.view_fs_top_playercontrol.view.*

class ShortVideoLandscapeActionBar(context: Context, attrs: AttributeSet?) : RelativeLayout(context, attrs) {

    companion object {
        // 限制title的字数最大30
        private const val TITLE_LIMIT_LEN: Int = 30
    }

    // 分享
    var mShare: CommonShare? = null

    private var mVideoDetail: VideoBean? = null
    private var mSettingsDlg: DefinitionSelectDlg? = null
//    private var mMediaInfoPacket: MediaInfoPacket? = null
//    private var mDownloadBtnListener: OnClickListener? = null
//    private val mDownloadListener: ICourseDownloadListener = object : ICourseDownloadListener {
//        override fun onStatus(state: Int, code: Int, message: String, downloadTask: DownloadTask) {
//            if (TextUtils.equals(downloadTask.taskId, mMediaInfoPacket!!.taskId)) {
//                updateDownloadBtnState(downloadTask)
//            }
//        }
//
//        override fun onProgress(progress: Long, total: Long, normalSpeed: Int,
//                                accelerateSpeed: Int, downloadTask: DownloadTask) {
//            if (TextUtils.equals(downloadTask.taskId, mMediaInfoPacket!!.taskId)) {
//                updateDownloadBtnState(downloadTask)
//            }
//        }
//    }

    init {
        val inflater = context
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE) as LayoutInflater
        inflater.inflate(R.layout.view_fs_top_playercontrol, this)
        initView()
    }

    fun setTitleText(titleString: String?) {
        if (titleString != null) {
            action_title_center.text = Html.fromHtml(titleString).toString()
        }
    }

    fun setTitleLenLimit(lenLimit: Int) {
        action_title_center.maxEms = lenLimit
    }

    private fun initView() {
        setDlnaBtnVisible(false)
        setFavBtnVisible(isVisible = false, isFav = false)
        setDownloadBtnVisible(false)
        setShareBtnVisible(true)
        setTitleLenLimit(TITLE_LIMIT_LEN)

//        offline_add_download.setWiteModal()
//        mDownloadBtnListener = OnClickListener {
//            Report.reportClick("start_download")
//            if (mMediaInfoPacket == null) {
//                return@OnClickListener
//            }
//            val task = CourseDownloadManager.getInstance().getTaskWithTaskId(mMediaInfoPacket!!.taskId)
//            if (task == null) {
//                addDownload()
//                offline_add_download.state = OfflineDownloadCourseInfo.LessonInfo.DownLoadState.WAITING
//            } else {
//                if (task.isPause || task.isError) {
//                    CourseDownloadManager.getInstance().startTask(task)
//                } else if (task.isWaiting || task.isDownloading) {
//                    CourseDownloadManager.getInstance().pauseTask(task)
//                }
//            }
//        }
//        offline_add_download_wraper.setOnClickListener(mDownloadBtnListener)
//        offline_add_download.setOnClickListener(mDownloadBtnListener)
        action_bar_back.setOnClickListener { (context as Activity).finish() }

        setShareBtnListener(OnClickListener {
            if (mVideoDetail == null) {
                return@OnClickListener
            }

            if (mShare == null) {
                mShare = CommonShare(context as Activity, ShareSelector.OnShareItemSelectListener {
                    MiscUtils.hideSystemUI((context as Activity).window.decorView)
                })
            }
            ShortVideoShareUtil.executeShareAction(
                    context as Activity,
                    mShare,
                    mVideoDetail
            )
        })

        initSettingBtn()
    }

    private fun initSettingBtn() {
        val listener = OnClickListener {
            showSettingDlg()
        }
        settings.setOnClickListener(listener)
        settings_wraper.setOnClickListener(listener)
    }

//    private fun initDownload() {
//        if (mMediaInfoPacket == null) {
//            return
//        }
//        val task = CourseDownloadManager.getInstance().getTaskWithTaskId(mMediaInfoPacket!!.taskId)
//        run {
//            offline_add_download.visibility = View.VISIBLE
//            if (task != null) {
//                updateDownloadBtnState(task)
//            } else {
//                offline_add_download.state = OfflineDownloadCourseInfo.LessonInfo.DownLoadState.PAUSE
//            }
//            CourseDownloadManager.getInstance().addTaskListener(mMediaInfoPacket!!.termId, mDownloadListener)
//        }
//    }
//
//    private fun updateDownloadBtnState(task: DownloadTask) {
//        when {
//            task.isDownloading -> {
//                offline_add_download.state = OfflineDownloadCourseInfo.LessonInfo.DownLoadState.DOWNLOADING
//                offline_add_download.setPercentage(task.progress)
//            }
//            task.isWaiting -> {
//                offline_add_download.state = OfflineDownloadCourseInfo.LessonInfo.DownLoadState.WAITING
//            }
//            task.isFinish -> {
//                offline_add_download.state = OfflineDownloadCourseInfo.LessonInfo.DownLoadState.DONE
//            }
//            else -> {
//                offline_add_download.state = OfflineDownloadCourseInfo.LessonInfo.DownLoadState.PAUSE
//            }
//        }
//    }
//
//    fun setPlayInfo(info: MediaInfoPacket?) {
//        unListenDownloadEvt()
//        mMediaInfoPacket = info
//        initDownload()
//    }
//
//    private fun addDownload() {
//        if (mMediaInfoPacket == null) {
//            return
//        }
//        CourseDownloadManager.getInstance().addAndStartTask(mMediaInfoPacket!!.courseId, mMediaInfoPacket!!.termId, mMediaInfoPacket!!.taskId)
//    }
//
//    fun unListenDownloadEvt() {
//        if (mMediaInfoPacket != null) {
//            CourseDownloadManager.getInstance().removeTaskListener(mMediaInfoPacket!!.termId, mDownloadListener)
//        }
//    }
//
//    //当没报名时点击下载按钮提示报名
//    fun switchDownloadBtnClickListener(listener: OnClickListener?) {
//        if (listener == null) {
//            offline_add_download.setOnClickListener(mDownloadBtnListener)
//            offline_add_download_wraper.setOnClickListener(mDownloadBtnListener)
//        } else {
//            offline_add_download.setOnClickListener(listener)
//            offline_add_download_wraper.setOnClickListener(listener)
//        }
//    }

    fun setDownloadBtnVisible(isVisible: Boolean) {
        offline_add_download.visibility = if (isVisible) View.VISIBLE else View.GONE
        offline_add_download_wraper.visibility = if (isVisible) View.VISIBLE else View.GONE
        if (!isVisible) {
            offline_add_download.setOnClickListener(null)
            offline_add_download_wraper.setOnClickListener(null)
        }
    }

    fun showWithAnimation(show: Boolean, animation: AlphaAnimation?) {
        // 防止隐藏后再隐藏，控制面板闪一下
        if (visibility == (if (show) View.VISIBLE else View.GONE)) {
            return
        }
        show(show)
        startAnimation(animation)
    }

    fun setDlnaBtnVisible(isVisible: Boolean) {
        dlna_wrapper.visibility = if (isVisible) View.VISIBLE else View.GONE
        dlna.visibility = if (isVisible) View.VISIBLE else View.GONE
    }

    fun setFavBtnVisible(isVisible: Boolean, isFav: Boolean) {
        btn_fav.visibility = if (isVisible) View.VISIBLE else View.GONE
        fav_wrapper.visibility = if (isVisible) View.VISIBLE else View.GONE
        btn_fav.setImageResource(if (isFav) R.drawable.ic_knowledge_fav_landscape else R.drawable.ic_knowledge_fav_normal)
    }

    fun setShareBtnVisible(isVisible: Boolean) {
        btn_share.visibility = if (isVisible) View.VISIBLE else View.GONE
        share_wrapper.visibility = if (isVisible) View.VISIBLE else View.GONE
    }

    fun setSWindowBtnVisible(isVisible: Boolean) {
        btn_swindow.visibility = if (isVisible) View.VISIBLE else View.GONE
        swindow_wraper.visibility = if (isVisible) View.VISIBLE else View.GONE
    }

    fun setFavBtnListener(onClickListener: OnClickListener) {
        btn_fav.setOnClickListener(onClickListener)
        fav_wrapper.setOnClickListener(onClickListener)
    }

    fun setShareBtnListener(onClickListener: OnClickListener) {
        btn_share.setOnClickListener(onClickListener)
        share_wrapper.setOnClickListener(onClickListener)
    }

    fun setPipBtnListener(onClickListener: OnClickListener) {
        btn_swindow.setOnClickListener(onClickListener)
        swindow_wraper.setOnClickListener(onClickListener)
    }

    private fun showSettingDlg() {
        if (mSettingsDlg == null) {
            mSettingsDlg = DefinitionSelectDlg(context, R.style.Dialog_HalfFullscreen)
        } else if (mSettingsDlg!!.isShowing) {
            mSettingsDlg!!.dismiss()
        }

        mSettingsDlg!!.show()
    }

    fun show(show: Boolean) {
        clearAnimation()
        visibility = if (show) View.VISIBLE else View.GONE
    }

    fun setVideoDetail(data: VideoBean) {
        this.mVideoDetail = data
        setTitleText(data.videoName)
    }

}