package com.tencent.edu.module.userinterest.viewmodel

import android.content.res.ColorStateList
import android.graphics.Color
import android.text.SpannableStringBuilder
import android.view.View
import androidx.lifecycle.ViewModel
import com.tencent.edu.common.utils.UnPeekLiveData
import com.tencent.edu.module.userinterest.data.UserInterestInfo
import com.tencent.edu.module.userinterest.view.EduInterestTagFlowLayout

internal class UserInterestViewModel : ViewModel() {
    val isFromWelfare = UnPeekLiveData<Boolean>()

    var tipsColor = UnPeekLiveData<ColorStateList>()
    var tipsText = UnPeekLiveData<String>()

    val selectedText = UnPeekLiveData<SpannableStringBuilder>()

    val onClickListener = UnPeekLiveData<View.OnClickListener>()

    val isFinishEnable = UnPeekLiveData<Boolean>()

    val interestInfo = UnPeekLiveData<UserInterestInfo>()
    val interestClickListener = UnPeekLiveData<EduInterestTagFlowLayout.OnInterestTagClickListener>()

    init {
        tipsColor.value = ColorStateList.valueOf(Color.parseColor("#777777"))
        tipsText.value = "已选择0个学院"
    }

    fun setIsFromWelfare(isFromWelfare: Boolean) {
        this.isFromWelfare.value = isFromWelfare
    }

    fun setTagTipsView(color: ColorStateList?, text: String) {
        if (color != null) {
            tipsColor.value = color
        }
        tipsText.value = text
    }

    fun setSelectedText(text: SpannableStringBuilder) {
        selectedText.value = text
    }

    fun setOnClickListener(listener: View.OnClickListener) {
        onClickListener.value = listener
    }

    fun setIsFinishEnable(enable: Boolean) {
        isFinishEnable.value = enable
    }

    fun seInterestInfo(info: UserInterestInfo) {
        interestInfo.value = info
    }

    fun setInterestClickListener(listener: EduInterestTagFlowLayout.OnInterestTagClickListener) {
        interestClickListener.value = listener
    }

}